/**********************************/
/*  L Y N X                       */ 
/*  Projet "demo"                 */ 
/*  Frdric Descharmes           */
/*  Septembre 2004                */
/**********************************/
 
#include <lynx.h>
#include <lynxlib.h>

#define SCREEN (MEMTOP-8160)
#define RENDER (MEMTOP-16320)
#define MAX_LEVEL 22

#define TRUE  1
#define FALSE 0

/* LYNX-specific #defines: */
#define JOY_RIGHT  0x10
#define JOY_LEFT   0x20
#define JOY_DOWN   0x40
#define JOY_UP     0x80

#define BUTTON_OPTION1 0x08
#define BUTTON_OPTION2 0x04
#define BUTTON_INNER   0x02
#define BUTTON_OUTER   0x01

#define BUTTON_PAUSE   0x01

//La palette est redfinie
//couleur 0 -> noir
//couleurs 1  4 -> blanc
//couleurs 5  8 -> rouge
char pal[]={
	0x00,0x0F,0x0F,0x0F,0x0F,0x00,0x00,0x00,0x00,0x08,0x0F,0x0F,0x00,0x00,0x0F,0x0F,
	0x00,0xFF,0xFF,0xFF,0xFF,0x0F,0x0F,0x0F,0x0F,0x88,0x00,0x0F,0xF0,0xFF,0xF0,0xFA};

extern char sp000000[];
extern char sp000001[];
extern char damier[];

/* _SCB0     dc.b $c7,$10,$20    le c7 sert  grer la transparence */
/* _SCBx     dc.b $c0,$10,$20    le c0 = mode opaque                */

extern char SCB0[];
#asm         
_SCB0     dc.b $c0,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          ; Because we didn't use -C when calling SPRPCK we can
          ; use the same colour palette indexes for all tiles
          dc.b $01,$23,$45,$67,$89,$Ab,$cd,$ef
#endasm

// dfinitions des 8 SCB qui seront chaines
// remarque, il ne faudrait pas chainer 8 SCB comme a
// il est possible de faire mieux (cf exemples BLL)
// mais c'est plus comprhensible pour un premier exemple comme a
extern char SCB1[];
#asm         
_SCB1     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          ; Because we didn't use -C when calling SPRPCK we can
          ; use the same colour palette indexes for all tiles
          dc.b $01,$23,$45,$67,$89,$Ab,$cd,$ef
#endasm

extern char SCB2[];
#asm         
_SCB2     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          ; Because we didn't use -C when calling SPRPCK we can
          ; use the same colour palette indexes for all tiles
          dc.b $01,$23,$45,$67,$89,$Ab,$cd,$ef
#endasm

extern char SCB3[];
#asm         
_SCB3     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          ; Because we didn't use -C when calling SPRPCK we can
          ; use the same colour palette indexes for all tiles
          dc.b $01,$23,$45,$67,$89,$Ab,$cd,$ef
#endasm

extern char SCB4[];
#asm         
_SCB4     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          ; Because we didn't use -C when calling SPRPCK we can
          ; use the same colour palette indexes for all tiles
          dc.b $01,$23,$45,$67,$89,$Ab,$cd,$ef
#endasm

extern char SCB5[];
#asm         
_SCB5     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          ; Because we didn't use -C when calling SPRPCK we can
          ; use the same colour palette indexes for all tiles
          dc.b $01,$23,$45,$67,$89,$Ab,$cd,$ef
#endasm

extern char SCB6[];
#asm         
_SCB6     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          ; Because we didn't use -C when calling SPRPCK we can
          ; use the same colour palette indexes for all tiles
          dc.b $01,$23,$45,$67,$89,$Ab,$cd,$ef
#endasm

extern char SCB7[];
#asm         
_SCB7     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          ; Because we didn't use -C when calling SPRPCK we can
          ; use the same colour palette indexes for all tiles
          dc.b $01,$23,$45,$67,$89,$Ab,$cd,$ef
#endasm

extern char SCB8[];
#asm         
_SCB8     dc.b $c7,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          ; Because we didn't use -C when calling SPRPCK we can
          ; use the same colour palette indexes for all tiles
          dc.b $01,$23,$45,$67,$89,$Ab,$cd,$ef
#endasm


// prcalcul des positions x des sprites
int cosinus[72] = {
155	,
155	,
154	,
152	,
150	,
148	,
145	,
141	,
137	,
133	,
128	,
123	,
118	,
112	,
106	,
99	,
93	,
87	,
80	,
73	,
67	,
61	,
54	,
48	,
43	,
37	,
32	,
27	,
23	,
19	,
15	,
12	,
10	,
8	,
6	,
5	,
5	,
5	,
6	,
8	,
10	,
12	,
15	,
19	,
23	,
27	,
32	,
37	,
42	,
48	,
54	,
61	,
67	,
73	,
80	,
87	,
93	,
99	,
106	,
112	,
117	,
123	,
128	,
133	,
137	,
141	,
145	,
148	,
150	,
152	,
154	,
155	
};

// prcalcul des positions y des sprites
int h_off[72] ={
40	,
44	,
48	,
51	,
54	,
57	,
59	,
61	,
62	,
62	,
62	,
61	,
59	,
57	,
54	,
51	,
48	,
44	,
40	,
36	,
32	,
29	,
26	,
23	,
21	,
19	,
18	,
18	,
18	,
19	,
21	,
23	,
26	,
29	,
32	,
36	,
40	,
44	,
48	,
51	,
54	,
57	,
59	,
61	,
62	,
62	,
62	,
61	,
59	,
57	,
54	,
51	,
48	,
44	,
40	,
36	,
32	,
29	,
26	,
23	,
21	,
19	,
18	,
18	,
18	,
19	,
21	,
23	,
26	,
29	,
32	,
36		
};


// assembler vertical retrace syncronisation routine
void Vsync() 
{
#asm
vretrace:
	lda $fd0a
	bne vretrace
#endasm
}


/*********************/
/* wait for a button */
/*********************/
char WaitButton()
{
   char key;
   while ( (key = joystick) != BUTTON_OUTER)      ;
   /* wait for the button to be released */
   while ( joystick )      ;
   return key;
}

/**********************************************************************************/
/***																			***/
/***								PROGRAMME    								***/
/***																			***/
/**********************************************************************************/
main()
{
	char i1, i2, i3, i4, i5, i6, i7, i8;
	int k;
	char p1, p2;
	
	InitIRQ();
	CLI;

	SetBuffers(SCREEN,RENDER,0);

	SetRGB(pal);
	
	// cre la liste chaine (du dernier vers le premier pour les superpositions
	SCBNEXT(SCB8) = SCB7;
	SCBNEXT(SCB7) = SCB6;
	SCBNEXT(SCB6) = SCB5;
	SCBNEXT(SCB5) = SCB4;
	SCBNEXT(SCB4) = SCB3;
	SCBNEXT(SCB3) = SCB2;
	SCBNEXT(SCB2) = SCB1;
	SCBDATA(SCB1) = sp000001;
	SCBDATA(SCB2) = sp000000;
	SCBDATA(SCB3) = sp000000;
	SCBDATA(SCB4) = sp000000;
	SCBDATA(SCB5) = sp000000;
	SCBDATA(SCB6) = sp000000;
	SCBDATA(SCB7) = sp000000;
	SCBDATA(SCB8) = sp000000;

	SCBDATA(SCB0) = damier;

    // les 8 indices des sprites
	i1=14;
	i2=12;
	i3=10;
	i4=8;
	i5=6;
	i6=4;
	i7=2;
	i8=0;

	for(;;)
	{
		DrawFBox(0,0,160,102,0);

// fait la rotation de couleurs de manire lisible        
		p1=pal[1];
		p2=pal[17];
		for (k=1;k<8;k++)
		{
			pal[k]=pal[k+1];
			pal[k+16]=pal[k+17];

		}
		pal[8]=p1;
		pal[24]=p2;
// redfinit la nouvelle palette
		SetRGB(pal);

		DrawSprite(SCB0);

// les 8 sprites
		SCBX(SCB1) = cosinus[i1];
		SCBY(SCB1) = h_off[i1];
		SCBX(SCB2) = cosinus[i2];
		SCBY(SCB2) = h_off[i2];
		SCBX(SCB3) = cosinus[i3];
		SCBY(SCB3) = h_off[i3];
		SCBX(SCB4) = cosinus[i4];
		SCBY(SCB4) = h_off[i4];
		SCBX(SCB5) = cosinus[i5];
		SCBY(SCB5) = h_off[i5];
		SCBX(SCB6) = cosinus[i6];
		SCBY(SCB6) = h_off[i6];
		SCBX(SCB7) = cosinus[i7];
		SCBY(SCB7) = h_off[i7];
		SCBX(SCB8) = cosinus[i8];
		SCBY(SCB8) = h_off[i8];

		DrawSprite(SCB8);
		Vsync();
		SwapBuffers();

		i1++;
		i2++;
		i3++;
		i4++;
		i5++;
		i6++;
		i7++;
		i8++;
		if (i1 == 71) i1=0;
		if (i2 == 71) i2=0;
		if (i3 == 71) i3=0;
		if (i4 == 71) i4=0;
		if (i5 == 71) i5=0;
		if (i6 == 71) i6=0;
		if (i7 == 71) i7=0;
		if (i8 == 71) i8=0;
	}
}
